


%global force_sound_aplay       0
%global dbus_integration        0
%global gstreamer_integration   0
%global nm_integration          0
%global nm_libnm_integration    0
%global modular_x               0
%global dbus_glib_splt          0
%global bonjour_support         0
%global meanwhile_integration   0
%global use_gnome_open          0
%global perl_devel_separated    0
%global perl_embed_separated    0
%global api_docs                0
%global krb4_removed            0
%global nss_md2_disabled        0
%global vv_support              0
%global libidn_support          0
%global disable_evolution       0
%global split_evolution         0
%global use_system_certs        0
%global use_system_libgadu      0
%global build_only_libs         0
%global gstreamer_version       0.10
%global farstream_version       0.1

%global dbus_integration        1
%global gstreamer_integration   1
%global nm_integration          1
%global modular_x               1
%global dbus_glib_splt          1
%global bonjour_support         1
%global meanwhile_integration   1
%global perl_devel_separated    1
%global perl_embed_separated    1
%global api_docs                1
%global nss_md2_disabled        1
%global vv_support              1
%global libidn_support          1
%global use_system_certs        1
%global krb4_removed            1
%global split_evolution         1
%global use_system_libgadu      1
%global disable_evolution       1
%global split_evolution         0
%global gstreamer_version       1.0
%global farstream_version       0.2
%global gst1                    1
%global nm_libnm_integration    1
%ifarch %{valgrind_arches}
%global has_valgrind 1
%endif

Name:           pidgin
Version:        2.14.12
Release:    1%{?dist}
License:        BSD and GPLv2+ and GPLv2 and LGPLv2+ and MIT
URL:            http://pidgin.im/
Source0:        http://downloads.sourceforge.net/pidgin/pidgin-%{version}.tar.bz2
Provides:       gaim = 999:1

%if %{split_evolution}
%else
%if %{disable_evolution}
%endif
%endif

Source1:        purple-prefs.xml

Patch0:         pidgin-NOT-UPSTREAM-2.5.2-rhel4-sound-migration.patch
Patch1:         pidgin-2.14.4-valgrind.patch

Patch100:       pidgin-2.14.7-do-not-disable-wall.patch

Summary:        A Gtk+ based multiprotocol instant messaging client

%global glib_ver %(pkg-config --modversion glib-2.0 2>/dev/null || echo -n "999" | cut -d. -f 1,2)
BuildRequires: make
BuildRequires:  glib2-devel
Requires:       glib2 >= %{glib_ver}
Requires:       libpurple = %{version}-%{release}

BuildRequires:  autoconf
BuildRequires:  libtool
BuildRequires:  cyrus-sasl-devel
%if %{nss_md2_disabled}
BuildRequires:  nss-devel >= 3.12.3
%else
BuildRequires:  nss-devel
%endif

%if ! %{build_only_libs}
BuildRequires:  startup-notification-devel
BuildRequires:  gtk2-devel
BuildRequires:  desktop-file-utils
BuildRequires:  ncurses-devel
BuildRequires:  gtkspell-devel
%if ! %{disable_evolution}
BuildRequires:  evolution-data-server-devel
%endif
%endif

BuildRequires:  gettext
BuildRequires:  intltool
BuildRequires:  tcl-devel
BuildRequires:  tk-devel
BuildRequires:  libxml2-devel
BuildRequires:  libgnt-devel

%if ! %{krb4_removed}
BuildRequires:  krb5-devel
%endif
%if %{dbus_integration}
BuildRequires:  dbus-devel >= 0.60
BuildRequires:  python3
BuildRequires:  python3-devel
%endif
%if %{gstreamer_integration}
BuildRequires:  pkgconfig(gstreamer-%{gstreamer_version})
%endif
%if %{nm_integration}
%if %{nm_libnm_integration}
BuildRequires:  NetworkManager-libnm-devel >= 1.0.0
%else
BuildRequires:  NetworkManager-glib-devel
%endif
%endif
%if %{modular_x}
BuildRequires:  libSM-devel
BuildRequires:  libXScrnSaver-devel
%endif
%if %{use_gnome_open}
Requires:       libgnome
%else
Requires:       xdg-utils
%endif
%if %{dbus_glib_splt}
BuildRequires:  dbus-glib-devel >= 0.70
%endif
%if %{bonjour_support}
BuildRequires:  pkgconfig(avahi-client) pkgconfig(avahi-glib)
%endif
%if %{meanwhile_integration}
BuildRequires:  meanwhile-devel
%endif
%if %{perl_devel_separated}
BuildRequires:  perl-devel
BuildRequires:  perl-generators
%endif
%if %{perl_embed_separated}
BuildRequires:  perl(ExtUtils::Embed)
%endif
%if %{vv_support}
BuildRequires:  pkgconfig(farstream-%{farstream_version})
Requires:       gstreamer%{?gst1}-plugins-good
Requires:       gstreamer%{?gst1}-plugins-bad-free
%endif
%if %{libidn_support}
BuildRequires:  libidn-devel
%endif
%if %{use_system_libgadu}
BuildRequires:  libgadu-devel
%endif

%if %{api_docs}
BuildRequires:  doxygen
%endif

%if 0%{?has_valgrind}
BuildRequires:  valgrind-devel
%endif

%global __provides_exclude_from ^%{_libdir}/purple
%define __requires_exclude ^%(cat %{_builddir}/%{?buildsubdir}/plugins.list)|perl\\(Purple\\)

%description
Pidgin allows you to talk to anyone using a variety of messaging
protocols including AIM, MSN, Yahoo!, Jabber, Bonjour, Gadu-Gadu,
ICQ, IRC, Novell Groupwise, QQ, Lotus Sametime, Simple and Zephyr.
These protocols are implemented using a modular, easy to use design.
To use a protocol, just add an account using the account editor.

Pidgin supports many common features of other clients, as well as many
unique features, such as perl scripting, TCL scripting and C plugins.

Pidgin is not affiliated with or endorsed by America Online, Inc.,
Microsoft Corporation, Yahoo! Inc., or ICQ Inc.

%if %{split_evolution}
%package evolution
Summary:    Pidgin Evolution integration plugin
Requires:   %{name} = %{version}-%{release}

%description evolution
This package contains the Evolution integration plugin for Pidgin.

%endif


%package devel
Summary:    Development headers and libraries for pidgin
Requires:   %{name} = %{version}-%{release}
Requires:   libpurple-devel = %{version}-%{release}
Requires:   pkgconfig
Requires:   gtk2-devel
Provides:   gaim-devel = %{version}-%{release}


%description devel
The pidgin-devel package contains the header files, developer
documentation, and libraries required for development of Pidgin scripts
and plugins.

%package perl
Summary:    Perl scripting support for Pidgin
Requires:   libpurple = %{version}-%{release}
Requires:   libpurple-perl = %{version}-%{release}

%description perl
Perl plugin loader for Pidgin. This package will allow you to write or
use Pidgin plugins written in the Perl programming language.


%package -n libpurple
Summary:    libpurple library for IM clients like Pidgin and Finch
%if %{meanwhile_integration}
%endif
Requires:   glib2 >= %{glib_ver}
Requires:   cyrus-sasl-plain, cyrus-sasl-md5
Requires:   cyrus-sasl-scram
%if %{use_system_certs}
Requires:   ca-certificates
%endif
%if %{dbus_integration}
Requires:   python3-dbus
%endif

%description -n libpurple
libpurple contains the core IM support for IM clients such as Pidgin
and Finch.

libpurple supports a variety of messaging protocols including AIM, MSN,
Yahoo!, Jabber, Bonjour, Gadu-Gadu, ICQ, IRC, Novell Groupwise, QQ,
Lotus Sametime, Simple and Zephyr.


%package -n libpurple-devel
Summary:    Development headers, documentation, and libraries for libpurple
Requires:   libpurple = %{version}-%{release}
Requires:   pkgconfig
%if %{dbus_integration}
Requires:   dbus-devel >= 0.60
%endif
%if %{dbus_glib_splt}
Requires:   dbus-glib-devel >= 0.70
%endif

%description -n libpurple-devel
The libpurple-devel package contains the header files, developer
documentation, and libraries required for development of libpurple based
instant messaging clients or plugins for any libpurple based client.

%package -n libpurple-perl
Summary:    Perl scripting support for libpurple
Requires:   libpurple = %{version}-%{release}

%description -n libpurple-perl
Perl plugin loader for libpurple. This package will allow you to write or
use libpurple plugins written in the Perl programming language.


%package -n libpurple-tcl
Summary:    Tcl scripting support for libpurple
Requires:   libpurple = %{version}-%{release}

%description -n libpurple-tcl
Tcl plugin loader for libpurple. This package will allow you to write or
use libpurple plugins written in the Tcl programming language.


%package -n finch
Summary:    A text-based user interface for Pidgin
Requires:   glib2 >= %{glib_ver}
Requires:   libpurple = %{version}-%{release}

%description -n finch
A text-based user interface for using libpurple.  This can be run from a
standard text console or from a terminal within X Windows.  It
uses ncurses and our homegrown gnt library for drawing windows
and text.


%package -n finch-devel
Summary:    Headers etc. for finch stuffs
Requires:   finch = %{version}-%{release}
Requires:   libpurple-devel = %{version}-%{release}
Requires:   pkgconfig
Requires:   ncurses-devel

%description -n finch-devel
The finch-devel package contains the header files, developer
documentation, and libraries required for development of Finch scripts
and plugins.

%if %{api_docs}
%package -n pidgin-docs
Summary:    API docs for pidgin and libpurple
Requires:   pidgin = %{version}-%{release}
Provides:   libpurple-docs = %{version}-%{release}

%description -n pidgin-docs
Doxygen generated API documentation.

%endif

%prep
%setup -q
%if %{force_sound_aplay}
%patch0 -p1 -b .aplay
%endif
%patch1 -p1 -b .valgrind


%patch100 -p1 -b .do-not-disable-wall

cp %{SOURCE1} prefs.xml

if [ "%{use_gnome_open}" == "1" ]; then
    sed -i "s/value='xdg-open'/value='gnome-open'/" prefs.xml
fi

for file in finch/plugins/pietray.py libpurple/purple-remote libpurple/plugins/dbus-buddyicons-example.py \
            libpurple/plugins/startup.py libpurple/purple-url-handler libpurple/purple-notifications-example; do
    sed -i 's/env python3*/python3/' $file
done

%if 0%{?has_valgrind}
rm -f libpurple/valgrind.h
sed -ie 's/include "valgrind.h"/include <valgrind\/valgrind.h>/' libpurple/plugin.c
%endif

%build
SWITCHES="--with-extraversion=%{release}"
%if ! %{krb4_removed}
    SWITCHES="$SWITCHES --with-krb4"
%endif
    SWITCHES="$SWITCHES --enable-perl"
%if ! %{disable_evolution}
    SWITCHES="$SWITCHES --enable-gevolution"
%else
    SWITCHES="$SWITCHES --disable-gevolution"
%endif
%if %{dbus_integration}
    SWITCHES="$SWITCHES --enable-dbus"
    SWITCHES="$SWITCHES --with-python=%{__python3}"
%else
    SWITCHES="$SWITCHES --disable-dbus"
%endif
%if %{nm_integration}
    SWITCHES="$SWITCHES --enable-nm"
%else
    SWITCHES="$SWITCHES --disable-nm"
%endif
%if %{gstreamer_integration}
    SWITCHES="$SWITCHES --with-gstreamer=%{gstreamer_version}"
%else
    SWITCHES="$SWITCHES --without-gstreamer"
%endif
%if ! %{bonjour_support}
    SWITCHES="$SWITCHES --disable-avahi"
%endif
%if ! %{meanwhile_integration}
    SWITCHES="$SWITCHES --disable-meanwhile"
%endif
%if ! %{libidn_support}
    SWITCHES="$SWITCHES --disable-idn"
%endif
%if ! %{vv_support}
    SWITCHES="$SWITCHES --disable-vv"
%endif
%if %{use_system_certs}
    SWITCHES="$SWITCHES --with-system-ssl-certs=/etc/pki/tls/certs"
%endif
%if %{build_only_libs}
    SWITCHES="$SWITCHES --disable-consoleui --disable-gtkui"
%endif

autoreconf --force --install

%configure --enable-gnutls=no --enable-nss=yes --enable-cyrus-sasl \
           --enable-tcl --enable-tk \
           --disable-schemas-install $SWITCHES

make %{?_smp_mflags} V=1 LIBTOOL=/usr/bin/libtool

cd libpurple/plugins/
make one_time_password.so V=1 LIBTOOL=/usr/bin/libtool
cd -

%if %{api_docs}
make docs
find doc/html -empty -delete
%endif

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install LIBTOOL=/usr/bin/libtool

install -m 0755 libpurple/plugins/one_time_password.so %{buildroot}%{_libdir}/purple-2/

%if ! %{build_only_libs}
desktop-file-install --vendor pidgin --delete-original              \
                     --add-category X-Red-Hat-Base                  \
                     --dir %{buildroot}%{_datadir}/applications  \
                     %{buildroot}%{_datadir}/applications/pidgin.desktop
%endif

find %{buildroot} \( -name "*.la" -o -name "*.a" \) -exec rm -f {} ';'
find %{buildroot} -type f -name perllocal.pod -exec rm -f {} ';'
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -empty -exec rm -f {} ';'
rm -f %{buildroot}%{_libdir}/pidgin/relnot.so
rm -f %{buildroot}%{_bindir}/nullclient
mkdir -p %{buildroot}%{_sysconfdir}/purple/
install -m 644 prefs.xml %{buildroot}%{_sysconfdir}/purple/prefs.xml

rm -f %{buildroot}%{_libdir}/purple-2/liboscar.so
rm -f %{buildroot}%{_libdir}/purple-2/libjabber.so
rm -f %{buildroot}%{_libdir}/purple-2/libymsg.so

chmod -R u+w %{buildroot}/*

%find_lang pidgin

%if ! %{build_only_libs}
ln -sf pidgin %{buildroot}%{_bindir}/gaim
%endif

%if %{api_docs}
rm -rf html
rm -f doc/html/installdox
mv doc/html/ html/
mkdir -p %{buildroot}%{_datadir}/gtk-doc/html/
ln -sf ../../doc/pidgin-docs/html/ \
    %{buildroot}%{_datadir}/gtk-doc/html/pidgin
%endif

rm -f %{buildroot}%{_sysconfdir}/gconf/schemas/purple.schemas

find %{buildroot}/%{_libdir}/purple-2 -name \*.so\* -printf '%f|' | sed -e 's/|$//' > plugins.list

%if ! %{build_only_libs}
%files
%doc NEWS COPYING AUTHORS README ChangeLog doc/PERL-HOWTO.dox
%{_bindir}/pidgin
%{_bindir}/gaim
%{_libdir}/pidgin/
%exclude %{_libdir}/pidgin/perl
%if %{split_evolution}
%exclude %{_libdir}/pidgin/gevolution.so
%endif
%{_mandir}/man1/pidgin.*
%{_datadir}/applications/pidgin.desktop
%{_datadir}/pixmaps/pidgin/
%{_datadir}/icons/hicolor/*/apps/pidgin.*
%{_datadir}/metainfo/pidgin.appdata.xml

%if %{split_evolution}
%files evolution
%{_libdir}/pidgin/gevolution.so
%endif

%files perl
%{_mandir}/man3/Pidgin*
%{_libdir}/pidgin/perl/

%files devel
%{_includedir}/pidgin/
%{_libdir}/pkgconfig/pidgin.pc
%endif

%files -f pidgin.lang -n libpurple
%doc COPYING
%{_libdir}/purple-2/
%exclude %{_libdir}/purple-2/perl
%{_libdir}/libpurple.so.*
%{_datadir}/sounds/purple/
%dir %{_sysconfdir}/purple
%config(noreplace) %{_sysconfdir}/purple/prefs.xml
%if %{dbus_integration}
%{_bindir}/purple-client-example
%{_bindir}/purple-remote
%{_bindir}/purple-send
%{_bindir}/purple-send-async
%{_bindir}/purple-url-handler
%{_libdir}/libpurple-client.so.*
%doc libpurple/purple-notifications-example
%endif
%exclude %{_libdir}/purple-2/tcl.so
%exclude %{_libdir}/purple-2/perl.so
%exclude %{_libdir}/purple-2/perl/

%files -n libpurple-devel
%{_datadir}/aclocal/purple.m4
%{_libdir}/libpurple.so
%{_includedir}/libpurple/
%{_libdir}/pkgconfig/purple.pc
%if %{dbus_integration}
%{_libdir}/libpurple-client.so
%endif

%files -n libpurple-perl
%{_mandir}/man3/Purple*
%{_libdir}/purple-2/perl.so
%{_libdir}/purple-2/perl/

%files -n libpurple-tcl
%{_libdir}/purple-2/tcl.so

%if ! %{build_only_libs}
%files -n finch
%{_bindir}/finch
%{_libdir}/finch/
%{_mandir}/man1/finch.*

%files -n finch-devel
%{_includedir}/finch/
%{_libdir}/pkgconfig/finch.pc
%endif

%if %{api_docs}
%files -n pidgin-docs
%doc html
%{_datadir}/gtk-doc/html/*
%endif

%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.12-1
- initial build
